function [] = Length_GenerateData(array_bit_length,samples_per_bit, instances_per_type, modScheme, test_train)
%LENGTH_GENERATEDATA Summary of this function goes here
%   Detailed explanation goes here
 
bit_lengths = [0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25];
numSamples = array_bit_length*samples_per_bit;
numOutputs = length(bit_lengths);
%modScheme = "ASK";
preamble = [];
dataBits = [];
maxdataBits = 50;
startPosition = 0;
ampRatio = 0.5;
SNR = -6; %SNR is here in Voltage ratio / dB-Amplitude
periods = 1;
scew = 0;
scewMax = 2*pi/samples_per_bit;

XTrain = zeros(numSamples,1,1,instances_per_type*numOutputs);
YTrain = {};



for output_index = 1:length(bit_lengths)
    for iteration_number = 1:instances_per_type
        dataBits = randi([0 1],1,bit_lengths(output_index));
        if modScheme == "ASK"
            dataBits(1) = 1;
            dataBits(length(dataBits)) = 1;
        end
        
        %Randomized starting position from index 1 to highest that will
        %contain entire signal
        startPosition = randi([1 (array_bit_length-length(dataBits))]); %(array_bit_length-length(dataBits)+1)if last bit is allowed to be clipped at the end of sampled area
        scew = (randi([0 99])/100) *(2*pi)/(samples_per_bit*periods);
        instance = generate_RVM_signal2(modScheme, array_bit_length, [], dataBits, startPosition, ampRatio, SNR, samples_per_bit, periods, scew);
        
        
        
        XTrain(:,1,1,(output_index-1)*instances_per_type+iteration_number) = instance;
        YTrain = vertcat(YTrain, int2str(output_index-1));
        
    end
end

YTrain = categorical(YTrain);

if test_train == "train"
    if modScheme == "ASK"
        save('ASK_0SNR_lengths_10bs_TrainData','XTrain', 'YTrain');
    elseif modScheme == "FSK"
       save('FSK_0SNR_lengths_10bs_TrainData','XTrain', 'YTrain');
    elseif modScheme == "PSK"
        save('PSK_0SNR_lengths_10bs_TrainData','XTrain', 'YTrain');
    end           
end

%save('ASK_0SNR_lengths_10bs_TrainData','XTrain', 'YTrain');
%save('FSK_0SNR_lengths_10bs_TrainData','XTrain', 'YTrain');
%save('PSK_0SNR_lengths_10bs_TrainData','XTrain', 'YTrain');

XTest = XTrain;
YTest = YTrain;
if test_train == "test"
    if modScheme == "ASK"
        save('ASK_0SNR_lengths_10bs_ClassifyData','XTest', 'YTest');
    elseif modScheme == "FSK"
        save('FSK_0SNR_lengths_10bs_ClassifyData','XTest', 'YTest');
    elseif modScheme == "PSK"
        save('PSK_0SNR_lengths_10bs_ClassifyData','XTest', 'YTest');
    end
end
%save('ASK_0SNR_lengths_10bs_ClassifyData','XTest', 'YTest');
%save('FSK_0SNR_lengths_10bs_ClassifyData','XTest', 'YTest');
%save('PSK_0SNR_lengths_10bs_ClassifyData','XTest', 'YTest');




end

