function [] = Lengths_Neural_Network(modScheme)
%LENGTHS_NEURAL_NETWORK Summary of this function goes here
%   Detailed explanation goes here
layers = [
    %Input Layer
    imageInputLayer([1000 1 1])
    
    %First Convolutional Layer
    convolution2dLayer([200 1], 50,"Stride",[4 1], "Padding", [20 0 0 0])
    batchNormalizationLayer
    reluLayer
    
    %Second Convolutional Layer
    convolution2dLayer([50 1], 40, "Stride",[2 1], "Padding", [10 0 0 0])
    batchNormalizationLayer
    reluLayer
    
    convolution2dLayer([20 1], 30,"Stride",[2 1], "Padding", [5 0 0 0])
    batchNormalizationLayer
    reluLayer
    

    convolution2dLayer([10 1], 20, "Stride",[2 1], "Padding", [5 0 0 0])
    batchNormalizationLayer
    reluLayer

    
    
    %Output Layers
    fullyConnectedLayer(26)
    softmaxLayer
    classificationLayer];


analyzeNetwork(layers);

if modScheme == "ASK"
    disp("Training Neural Network for ASK")
    load('ASK_0SNR_lengths_10bs_TrainData.mat');
elseif modScheme =="FSK"
    disp("Training Neural Network for FSK")
    load('FSK_0SNR_lengths_10bs_TrainData.mat');
elseif modScheme == "PSK"
    disp("Training Neural Network for PSK")
    load('PSK_0SNR_lengths_10bs_TrainData.mat');
else
    disp("Unrecognized input. Aborting")
    return
end

%IF FFT:
%for i = 1:length(XTrain)
%    temp = fft(XTrain(:,:,1,i));
%    XTrain(:,:,1,i) = abs(temp);
%    XTrain(:,:,2,i) = unwrap(angle(temp));
%end

%options = trainingOptions('sgdm','MaxEpochs',500,'InitialLearnRate',1e-3,'Verbose',0,'Plots','training-progress');
options = trainingOptions('adam','MaxEpochs',100,'Verbose',0,'Plots','training-progress','ExecutionEnvironment','parallel');
net = trainNetwork(XTrain, YTrain,layers, options);


if modScheme == "ASK"
    save('ASK_0SNR_lengths_50b10_1period_sgdm_TrainedNetwork','net');
elseif modScheme =="FSK"
    save('FSK_0SNR_lengths_50b10_1period_sgdm_TrainedNetwork','net');
elseif modScheme == "PSK"
    save('PSK_0SNR_lengths_50b10_1period_sgdm_TrainedNetwork','net');
else
    disp("Unrecognized input")
end
end

