function [] = ASK_Full_GenerateData(array_bit_length,samples_per_bit, instances_per_type, modScheme,test_train)
%GENERATE_RVM_DATA Summary of this function goes here
%   Detailed explanation goes here

%generate_RVM_signal2(modulation_scheme,array_bit_length,preamble_bits, data_bits, 
%signal_start_index, signal_amplitude, snr, samples_per_bit,periods_per_bit,signal_scew)


%TO RUN PROGRAM: generate_RVM_data(25,8, 200)

%Variables that can be changed
numSamples = array_bit_length*samples_per_bit;
numOutputs = 8;
preamble = [1 0 1 0 1 0 1 1];
dataBits = [];
maxdataBits = 25;
startPosition = 0;
ampRatio = 0.5;
SNR = -6; %SNR is here in Voltage ratio / dB-Amplitude
periods = 1;
scew = 0;
scewMax = 2*pi/samples_per_bit;

XTrain = zeros(numSamples,1,1,instances_per_type*numOutputs);
YTrain = {};
typeIndex = 0;
%YTrain = vertcat(YTrain, variable);

%Output 0: No Preamble, No Data. No signal
typeIndex = 0;
for i= 1:instances_per_type
    instance = generate_RVM_signal2(modScheme,array_bit_length, [], [], startPosition, ampRatio, SNR, samples_per_bit, periods, scew);
    %max(instance)
    %mean(abs(instance))
    XTrain(:,1,1,i+typeIndex*instances_per_type) = instance;
    YTrain = vertcat(YTrain, '0');
end



%Output 1: Preamble. No Data
typeIndex = 1;
for i= 1:instances_per_type
    startPosition = randi([1 array_bit_length-length(preamble)+1]);
    preamble(length(preamble)) = randi([0 1],1,1);
    scew = (randi([0 99])/100) *(2*pi)/(samples_per_bit*periods);
    instance = generate_RVM_signal2(modScheme,array_bit_length, preamble, [], startPosition, ampRatio, SNR, samples_per_bit, periods, scew);
    
    XTrain(:,1,1,i+typeIndex*instances_per_type) = instance;
    YTrain = vertcat(YTrain, '1');
end


%Output 2: No Preamble. Data. No EoF
typeIndex = 2;
for i= 1:instances_per_type
    numData = randi([1 maxdataBits]);
    dataBits = randi([0 1],1,numData);
    %To make sure ASK finds something
    if modScheme == "ASK"
        dataBits(1) = 1;
    end
    if length(dataBits) >= length(preamble)
        while dataBits(1:length(preamble)) == preamble(1:length(preamble))
            dataBits(1:length(preamble)) = randi([0 1],1,length(preamble));
        end
    end
    startPosition = array_bit_length-length(dataBits)+1;
    scew = (randi([0 99])/100) *(2*pi)/(samples_per_bit*periods);
    instance = generate_RVM_signal2(modScheme,array_bit_length, [], dataBits, startPosition, ampRatio, SNR, samples_per_bit, periods, scew);   
    XTrain(:,1,1,i+typeIndex*instances_per_type) = instance;
    YTrain = vertcat(YTrain, '2');
end


%Output 3: No Preamble. Data. EoF
typeIndex = 3;
for i= 1:instances_per_type
    numData = randi([1 maxdataBits]);
    dataBits = randi([0 1],1,numData);
    scew = (randi([0 99])/100) *(2*pi)/(samples_per_bit*periods);
    
    if length(dataBits) >= length(preamble)
        while dataBits(1:length(preamble)) == preamble(1:length(preamble))
            dataBits(1:length(preamble)) = randi([0 1],1,length(preamble));
        end
    end
    %Because ASK cannot see zeroes:
    if modScheme == "ASK"
        dataBits(length(dataBits)) = 1;
    end
    startPosition = randi([1 array_bit_length-length(dataBits)]);
    instance = generate_RVM_signal2(modScheme,array_bit_length, [], dataBits, startPosition, ampRatio, SNR, samples_per_bit, periods, scew);
    
    XTrain(:,1,1,i+typeIndex*instances_per_type) = instance;
    YTrain = vertcat(YTrain, '3');
end

%Output 4: Preamble. No SoF. Data. No EoF.
preamble= [1 0 1 0 1 0 1 0];
typeIndex = 4;
for i= 1:instances_per_type
    numData = randi([1 maxdataBits]);
    dataBits = randi([0 1],1,numData);
    scew = (randi([0 99])/100) *(2*pi)/(samples_per_bit*periods);
    
    startPosition = array_bit_length-length(dataBits)-length(preamble)+1;
    instance = generate_RVM_signal2(modScheme,array_bit_length, preamble, dataBits, startPosition, ampRatio, SNR, samples_per_bit, periods, scew);
    
    XTrain(:,1,1,i+typeIndex*instances_per_type) = instance;
    YTrain = vertcat(YTrain, '4');
end


%Output 5: Premable. No SoF. Data. EoF
preamble = [1 0 1 0 1 0 1 0];
typeIndex = 5;
for i= 1:instances_per_type
    numData = randi([1 maxdataBits]);
    dataBits = randi([0 1],1,numData);
    scew = (randi([0 99])/100) *(2*pi)/(samples_per_bit*periods);
    
    %Because ASK cannot see zeroes:
    if modScheme == "ASK"
        dataBits(length(dataBits)) = 1;
    end
    startPosition = randi([1 array_bit_length-length(dataBits)-length(preamble)]);
    instance = generate_RVM_signal2(modScheme,array_bit_length, preamble, dataBits, startPosition, ampRatio, SNR, samples_per_bit, periods, scew);
    
    XTrain(:,1,1,i+typeIndex*instances_per_type) = instance;
    YTrain = vertcat(YTrain, '5');
end

%Output 6: Preamble. SoF. Data. No EoF
preamble= [1 0 1 0 1 0 1 1];
typeIndex = 6;
for i= 1:instances_per_type
    numData = randi([1 maxdataBits]);
    dataBits = randi([0 1],1,numData);
    scew = (randi([0 99])/100) *(2*pi)/(samples_per_bit*periods);

    startPosition = array_bit_length-length(dataBits)-length(preamble)+1;
    instance = generate_RVM_signal2(modScheme,array_bit_length, preamble, dataBits, startPosition, ampRatio, SNR, samples_per_bit, periods, scew);
    
    XTrain(:,1,1,i+typeIndex*instances_per_type) = instance;
    YTrain = vertcat(YTrain, '6');
end

%Output 7: Preamble. SoF. Data. EoF
preamble = [1 0 1 0 1 0 1 1];
typeIndex = 7;
for i= 1:instances_per_type
    numData = randi([1 maxdataBits]);
    dataBits = randi([0 1],1,numData);
    scew = (randi([0 99])/100) *(2*pi)/(samples_per_bit*periods);
    
    %Because ASK cannot see zeroes:
    if modScheme == "ASK"
        dataBits(length(dataBits)) = 1;
    end
    startPosition = randi([1 array_bit_length-length(dataBits)-length(preamble)]);
    instance = generate_RVM_signal2(modScheme,array_bit_length, preamble, dataBits, startPosition, ampRatio, SNR, samples_per_bit, periods, scew);
    
    XTrain(:,1,1,i+typeIndex*instances_per_type) = instance;
    YTrain = vertcat(YTrain, '7');
end







%
%typeIndex = 1;
%for i= 1:instances_per_type
%    numData = randi([1 maxdataBits]);
%    dataBits = randi([0 1],1,numData);
%    dataBits(1) = 1;
%    startPosition = randi([1 array_bit_length-length(dataBits)]);
%    instance = generate_RVM_signal2(modScheme,array_bit_length, preamble, dataBits, startPosition, ampRatio, SNR, samples_per_bit, periods, scew);
%    
%    XTrain(:,1,1,i+typeIndex*instances_per_type) = instance;
%    YTrain = vertcat(YTrain, '1');
%end



YTrain = categorical(YTrain);

if test_train == "train"
    if modScheme == "ASK"
        save('ASK_Full_TrainData','XTrain', 'YTrain');
    elseif modScheme == "FSK"
       save('FSK_Full_TrainData','XTrain', 'YTrain');
    elseif modScheme == "PSK"
        save('PSK_Full_TrainData','XTrain', 'YTrain');
    end           
end

XTest = XTrain;
YTest = YTrain;
if test_train == "test"
    if modScheme == "ASK"
        save('ASK_Full_ClassifyData','XTest', 'YTest');
    elseif modScheme == "FSK"
        save('FSK_Full_ClassifyData','XTest', 'YTest');
    elseif modScheme == "PSK"
        save('PSK_Full_ClassifyData','XTest', 'YTest');
    end
end







%save('ASK_0SNR_Full_10bs_TrainData','XTrain', 'YTrain');
%save('FSK_0SNR_Full_10bs_TrainData','XTrain', 'YTrain');
%save('PSK_0SNR_Full_10bs_TrainData','XTrain', 'YTrain');

%XTest = XTrain;
%YTest = YTrain;
%save('ASK_0SNR_Full_10bs_ClassifyData','XTest', 'YTest');
%save('FSK_0SNR_Full_10bs_ClassifyData','XTest', 'YTest');
%save('PSK_0SNR_Full_10bs_ClassifyData','XTest', 'YTest');
end

